#!/bin/bash

HTPASSWD=/SpliceCom/config/customerhtpasswd

if [ "$REMOTE_USER" ]; then
	tmpdir="/SpliceCom/Sites/Vision/logoutd.$REMOTE_USER"
	[ -e "$tmpdir" ] && rm -rf "$tmpdir"
	mkdir "$tmpdir"
	if [ $? -ne 0 ]; then
		echo "failed to create temporary directory: $tmpdir" >/dev/stderr
		exit
	fi
	awk -F: -v name="$REMOTE_USER" '{if ($1!=name) print $0}' $HTPASSWD > "$tmpdir/customerhtpasswd"
	if [ $? -ne 0 ]; then
		echo "failed to create temporary credentials" >/dev/stderr
		exit
	fi
	cat >"$tmpdir/.htaccess" <<EOF
AuthType Basic
AuthName "Password Required"
AuthUserFile "$tmpdir/customerhtpasswd"
Require valid-user
<Files "customerhtpasswd">
	<IfModule !mod_authz_core.c>
		Order allow,deny
		Deny from all
	</IfModule>
	
	<IfModule mod_authz_core.c>
		Require all denied
	</IfModule>
</Files>
EOF
	if [ $? -ne 0 ]; then
		echo "failed to create .htaccess" >/dev/stderr
		exit
	fi
	cat >"$tmpdir/index.html" <<EOF
<html><head><meta http-equiv="refresh" content="0; url=/vision/"></head></html>
EOF
	cat <<EOF
Content-type: text/html

<html><head><meta http-equiv="refresh" content="0; url=/vision/logoutd.$REMOTE_USER/index.html"></head></html>
EOF
fi

