var changed = false;

window.addEventListener("beforeunload", function (e) {
	if( changed ) {
		need_focus = true;
		
		// Cancel the event as stated by the standard.
		e.preventDefault();

		// The browser will replace this text with its own
		var message = "There are unsaved changes. Really leave ?",  e = e || window.event;
		// For IE and Firefox
		if (e) {
			e.returnValue = message;
		}

		// For Safari
		return message;
	}
});
	
$(document).ready(function() {

	$('#ccccqdiv').on('ready.jstree', function(e, data) {
		var flat_array = data.instance.get_json('#', {flat: true, no_state: true, no_li_attr: true, no_a_attr: true});
		var i, num = flat_array.length;
		if (num>0) {
			for (i=0; i<num; i++) {
				var node = data.instance.get_node(flat_array[i].id);
				if (node) {
					if ((node.original.enabled == '1') && (node.original.folder == '0')) {
						data.instance.check_node(node);
						var pid1 = node.parent;
						if (pid1 != '0') {
							data.instance.open_node(pid1);
							var pid2 = data.instance.get_parent(pid1);
							if (pid2 != '0') {
								data.instance.open_node(pid2);
							}
						}
					}
				}
			}
		}
		
		data.instance.open_node('0');
		changed = false;
	})
	.on('select_node.jstree', function(node, selected, event) {
		var instance = $(this).jstree(true);
		instance.open_node(selected.selected);
		changed = true;
	})
	.on('deselect_node.jstree', function(node, selected, event) {
		changed = true;
	})
	.jstree({
		"checkbox" : {
			"whole_node" : true
		},
		"plugins" : [ "types", "checkbox" ],
		'core' : {
			'data' : {
				'url' : window.location.href.split('#')[0] + '&action=getccccq'
			}
		},
		"types": {
			"extend_type" : {
				a_attr:  { "has_extend" : "1" }
			}
		}
	});
	
	$('#applyccccq').click(function (ev) {
		$('#ccccqerr').hide();
		var instance = $('#ccccqdiv').jstree(true);
		var flat_array = instance.get_json('#', {flat: true});

		var post_data = '[';
		var i, num = flat_array.length, added=0;
		if (num>0) {
			for (i=0; i<num; i++) {
				var node = instance.get_node(flat_array[i].id);
				if (node) {
					if ((node.id == '0') || (node.original.folder == '1'))
						continue;
				}
				
				if ( flat_array[i].state.selected ) {
					if (added++ > 0)
						post_data = post_data + ',';
					post_data = post_data + '"' + flat_array[i].id + '"';
				}
			}
			post_data += ']';
				
			$.ajax({
				method: 'POST',
				url: window.location.href.split('#')[0] + '&action=setccccq',
				contentType: 'application/x-json',
				data: post_data,
				success: function (data,textStatus,jqXHR) {
					// response has already been converted from JSON to JS object
					if ((typeof data.result != 'undefined') && (data.result == 'OK')) {
						changed = false;
						var newloc = window.location.href.replace("pagename=q.edit.cc","pagename=q.main");
						window.location.replace(newloc);
					} else {
						alert('Failed to update codes for queue');
						if (typeof data.result != 'undefined')
							console.log('ccccq.js: '+data.result);
					}
				}
			});
		}
	});
	
	$('#cancelccccq').click(function (ev) {
		var newloc = window.location.href.replace("pagename=q.edit.cc","pagename=callreport");
		window.location.replace(newloc);
	});
	
	$('#allccccq').click(function (ev) {
		var instance = $('#ccccqdiv').jstree(true);
		instance.select_all(true);
	});
	
	$('#noneccccq').click(function (ev) {
		var instance = $('#ccccqdiv').jstree(true);
		instance.deselect_all(true);
	});
});
