var timer1;

$.fn.exists = function () {
    return this.length !== 0;
}

function add_row(t, c1, c2) {
	if (c2.length < 1)
		return t;

	return t + "<tr><td>" + c1 + "</td><td>" + c2 + "</td></tr>";
}

function status_update() {
	var text = $('#purge_status > td').children().first();

	if (!text.exists())
		return false;
	
	$.ajax({
		url: "purge.json",
		error: function(jqXHR, textStatus, errorThrown) {
			if (timer1 !== undefined)
				clearInterval(timer1);

			setTimeout(function () {
				window.location.reload(true);
			}, 1000);
		},
		success: function (data) {
			var html = "<table class='purge'><tr><th colspan='2'>Purge is active</th></tr>";
			if (typeof data.start !== "undefined")
				html = add_row(html, "Purge Started", data.start);
			if (typeof data.rt_state !== "undefined") {
				if (data.rt_state == "sleeping")
					html = add_row(html, "State", "Waiting on Time Plan");
				else
					html = add_row(html, "State", data.rt_state);
			}
			if (typeof data.rt_table_name !== "undefined") {
				if ((typeof data.num_tables !== "undefined") && (typeof data.table_num !== "undefined"))
					html = add_row(html, "Current Table", data.rt_table_name + " (" + data.table_num + " of " + data.num_tables + ")");
				else
					html = add_row(html, "Current Table", data.rt_table_name);
			}
			if (typeof data.rt_start !== "undefined")
				html = add_row(html, "Table Started", data.rt_start);
			if (typeof data.rt_end !== "undefined")
				html = add_row(html, "Estimated table complete", data.rt_end);
			if (typeof data.rt_percent !== "undefined")
				html = add_row(html, "Table percentage complete", data.rt_percent);
			html += "</table>";
			text.replaceWith(html);
		}
	});

	return true;
}

$(document).ready(function() {
	if (status_update())
		timer1 = setInterval(status_update, 10000);
});
